<?php

/**

 * Liste les  groupes
 * @Version $Id$
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: annu
 * file: grouplist_csv.php
 */
// ====================================
// Portion de code correspondant a la partie entete.inc.php sans l'affichage HTML
session_name("Sambaedu");
@session_start();
$_SESSION["pageaide"] = "Table_des_mati&#232;res";

require_once ("config.inc.php");
require_once ("ldap.inc.php");
require_once ("functions.inc.php");
require_once ("ent.inc.php");
require_once ("lang.inc.php");
bindtextdomain('se4-core', "/var/www/sambaedu/locale");
textdomain('se4-core');

require_once ("traitement_data.inc.php");

$login = isauth();

// Prise en compte de la page demandee initialement - leb 25/6/2005
if ($login == "") {
    // header("Location:$urlauth");
    $request = $_SERVER['PHP_SELF'];
    if ($_SERVER['QUERY_STRING'] != "") {
        $request .= "?" . $_SERVER['QUERY_STRING'];
    }

    echo "<script language=\"JavaScript\" type=\"text/javascript\">\n<!--\n";
    echo "top.location.href = '$urlauth?request=" . rawurlencode($request) . "';\n";
    echo "//-->\n</script>\n";

    // Pour prevenir une poursuite dans le cas ou javascript serait desactive sur le client
    die();
} else {
    // ====================================
    // include "entete.inc.php";
    include_once "ldap.inc.php";
    include "ihm.inc.php";
    $filter = $_GET['filter'];
    if ((have_right($config, "Annu_is_admin")) || (have_right($config, "sovajon_is_admin"))) {
        // require ("siecle.inc.php");
        $group = search_ad($config, $filter, "group", $config['dn']['groups']);
        // $people = search_people_group($config, $filter);
        $people = search_ad($config, "*", "user", $config["dn"]["people"], [
            "pwdlastset"
        ]);

        if (count($people)) {

            // $nom_fic = "nom_du_groupe.csv";
            $nom_fic = "$filter.csv";
            $now = gmdate('D, d M Y H:i:s') . ' GMT';
            header('Content-Type: text/x-csv');
            header('Expires: ' . $now);
            // lem9 & loic1: IE need specific headers
            if (preg_match('/MSIE/', $_SERVER['HTTP_USER_AGENT'])) {
                header('Content-Disposition: inline; filename="' . $nom_fic . '"');
                header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                header('Pragma: public');
            } else {
                header('Content-Disposition: attachment; filename="' . $nom_fic . '"');
                header('Pragma: no-cache');
            }
            sync_ent($config);
            $ent = apcu_fetch('ent');

            // $contenu_fichier='';
            $contenu_fichier = "login;originalLogin;fullName;lastName;firstName;birthDate;sex;email;allClasses;activated;code\n";

            for ($loop = 0; $loop < count($people); $loop ++) {
                // preg_match("/([0-9]{8})/",$people[$loop]["gecos"],$naiss);

                $groupes = $people[$loop]["memberof"];
                foreach ($groupes as $groupe) {
                    if ($groupe == $group[0]['dn']) {
                        $list = [];
                        foreach ($groupes as $classe) {
                            if (preg_match("/CN=Classe_(.*),/U", $classe, $m)) {
                                $list[] = $m[1];
                                break;
                            }
                        }
                        $list = implode(',', $list);
                        if ($people[$loop]['pwdlastset'] == 0) {
                            $actif = 0;
                        } else {
                            $actif = 1;
                        }
                        if ($ent) {
                            $code = $ent[array_search($people[$loop]["cn"], array_column($ent, "login"))]['code'] ?? "";
                        }

                        $originallogin = explode("@", $people[$loop]['userprincipalname'])[0];
                        $contenu_fichier .= $people[$loop]["cn"] . ";" . $originallogin . ";" . $people[$loop]["fullname"] . ";" . $people[$loop]["nom"] . ";" . $people[$loop]["prenom"] . ";" . $people[$loop]["date"] . ";" . $people[$loop]["sexe"] . ";" . $people[$loop]["email"] . ";" . $list . ";" . $actif . ";" . $code . "\n";
                    }
                }
            }
            echo $contenu_fichier;
        } else {
            include "entete.inc.php";
            echo " <STRONG>" . gettext("Pas de membres") . " </STRONG> " . gettext(" dans le groupe") . " $filter.<BR>";
            include ("pdp.inc.php");
        }
    }
}
?>
