<?php
/*
 * génération d'un fichier applications-$action.cmd, qui est lancé depuis la gpo "se4_applications" qui execute un script au startup/logon/logoff/shutdown
 *
 * curl.exe -F "os=windows" -F "action=$action" -F "user=%username%" -F "machine=%computername%" "http://###_SE4FS_NAME_###/gpo/applications.php">%windir%\applications-$action.cmd
 * if exist %windir%\applications-$action.cmd (call %windir%\applications-$action.cmd)
 *
 * on passe le nom de la machine le script et user, et on récupère un fichier cmd ou bash qui est exécuté au boot ou a l'ouverture de session
 *
 */
// génération des scripts à exécuter pour la configuration des applications.
// on génere un script à partir des modèles dans /etc/sambaedu/applications/* (personnalisations locales) ou /usr/share/sambaedu/applications/* (scripts de la distrib). Le local est prioritaire.
// windows : $action.windows
// linux : $action.linux
// les modèles peuvent contenir des substitutions de variables de conf : ###_PARAMETRE_###, ils seront remplacés automatiquement
// pour les scripts dans /etc/   il est possible de passer un nom, groupe, parc, machine : startup@parc.linux par exemple
// bien evidemment seuls les parcs seront pris en compte lors du statup, vu qu'il n'y a pas de user à ce stade.
//
// Les scripts générés sont typiquement utilisés pour DL des fichiers de conf, et le copier au bon endroit
//
require "config.inc.php";
require "ldap.inc.php";
require "logs.inc.php";

$machine = $_POST['machine'] ?? $_GET['machine'] ?? "";
$action = $_POST['action'] ?? $_GET['action'] ?? "";
$os = $_POST['os'] ?? $_GET['os'] ?? "";
$user = $_POST['user'] ?? $_GET['user'] ?? "";
$application = $_POST['application'] ?? "";
$scripts = [];

function once_script($path, $app, $action, $local, $os, &$scripts)
{
    if ($local) {
        $local = ".local";
        $path = "/etc/sambaedu/applications/";
    } else {
        $local = "";
        $path = "/usr/share/sambaedu/applications/";
    }
    $filename = $path . $app . "/" . $action . "-once." . $os;
    if (file_exists($filename)) {
        $md5 = md5_file($filename);
        if ($os == "linux") {
            $scripts[$app . "-once.local"] = "
[ -f \"/etc/sambaedu/applications/$app-once$local.md5\" ] && . /etc/sambaedu/applications/$app-once$local.md5
if [ \"\$app-once.local.md5\" != \"$md5\"] ; then
";
            $scripts[$app . "-once$local"] .= file($filename);
            $scripts[$app . "-once$local"] .= "
echo \"$app-once$local.md5=$md5\">\"/etc/sambaedu/applications/$app-once$local.md5\"
fi";
        }
        // pas de once pour les windows
    }
}

if ($user == "Debian-gdm" || $user == "root") {
    // pas de script
    exit();
}

// ajout de la gestion des parcs/groupes/wpkg
if (! empty($machine)) {
    $machinel = search_machine($config, $machine);
} else {
    $machinel = [];
}
if (! empty($user)) {
    $userl = search_user($config, $user);
    exec("/usr/share/sambaedu/shares/share.avail/mkhome.sh " . $user);
} else {
    $cnx_user = get_machine_status($config, $machinel['cn']);
    if (! empty($cnx_user['user'][0]['name'])) {
        $userl = search_user($config, $cnx_user['user'][0]['name']);
    }   
}
$user = $userl['cn'] ?? $user;
$machine = $machinel['cn'] ?? $machine;
$parcs = [];
if (! empty($machinel['dn'])) {
    $salle = ldap_dn2cn(ldap_dn2oudn($machinel['dn']));
    // $parcs[] = $machine['cn'];
    foreach ($machinel['memberof'] as $parc) {
        $parcs[] = ldap_dn2cn($parc);
    }
} else {
    $salle = "";
}
$groups = [];
$list_u = [];
if (isset($userl['cn'])) {
    foreach ($userl['memberof'] as $group) {
        $groups[] = ldap_dn2cn($group);
    }
    $list_u = array_unique(array_merge([
        $userl['cn']
    ], $groups));
}
$list = array_unique(array_merge($list_u, [
    $machinel['cn']
], [
    $salle
], $parcs));

//

if (! empty($action) && ! empty($os)) {
    // scripts officiels sambaedu
    $path = "/usr/share/sambaedu/applications/";
    if (empty($application)) {
        $apps = scandir($path);
    } else {
        $apps = [
            $application
        ];
    }
    $config['user'] = $user;
    $config['machine'] = $machine;
    foreach ($apps as $app) {
        if (file_exists($path . $app . "/" . $action . "." . $os)) {
            $scripts[$app] = file($path . $app . "/" . $action . "." . $os);
        }
        once_script($path, $app, $action, false, $os, $scripts);
    }
    // personnalisations locales si besoin
    $path = "/etc/sambaedu/applications/";
    if (empty($application)) {
        $apps = scandir($path);
    } else {
        $apps = [
            $application
        ];
    }
    if (file_exists("../includes/wpkg_lib.php")){
        require "wpkg_lib.php";
        require "wpkg_libsql.php";
        $liste_applications = array_map('strtolower', array_column(array_column(info_poste_applications($config, $machine), "info_app"), "id_nom_app"));
    } else {
        $liste_applications = [];
    }
     
    foreach ($apps as $app) {
        if (file_exists($path . $app . "/" . $action . "." . $os)) {
            $scripts[$app . ".local"] = file($path . $app . "/" . $action . "." . $os);
        }
        once_script($path, $app, $action, true, $os, $scripts);
        foreach ($list as $name) {
            if (file_exists($path . $app . "/" . $action . "@" . $name . "." . $os)) {
                $scripts[$app . "@" . $name . ".local"] = file($path . $app . "/" . $action . "@" . $name . "." . $os);
            }
        }
        // scripts à exécuter côté serveur (utilisateur root!)
        if (file_exists($path . $app . "/" . $action . "-server." . $os)) {
            $scripts_server[$app. ".local" ] = file($path . $app . "/" . $action . "-server." . $os);
        }
        foreach ($list as $name) {
            if (file_exists($path . $app . "/" . $action . "-server@" . $name . "." . $os)) {
                $scripts_server[$app . "@" . $name . ".local"] = file($path . $app . "/" . $action . "-server@" . $name . "." . $os);
            }
        }
        // scripts conditionnés au paquet wpkg, executés uniquement si l'application est activee pour le parc
        if (in_array($app, $liste_applications) && file_exists($path . $app . "/" . $action . "-wpkg." . $os)) {
            $scripts[$app. ".wpkg" ] = file($path . $app . "/" . $action . "-wpkg." . $os);
        }        
    }
 
    $header = [
        'windows' => "::cmd\r\n::" . $action . "\r\n:: script de configuration des applications windows\r\n",
        'linux' => "#!/bin/bash\n#" . $action . "\n# script de configuration des applications Linux\n"
    ];
    
    
    $out = [];
    foreach ($scripts_server as $script) {
        $out = array_merge($out, $script);
    }
    write_param($config, $out);
    $tmpfile = sys_get_temp_dir() . "/" . $action . "-" . microtime();
    $script = "#!/bin/bash";
    $script .= implode("", $out);
    file_put_contents($tmpfile, $script);
    exec("chmod +x " . $tmpfile);
    exec("sudo " . $tmpfile);
    unlink($tmpfile);
        
    
    $out = [];
    foreach ($scripts as $script) {
        $out = array_merge($out, $script);
    }
    write_param($config, $out);


    $out = $header[$os] . implode("", $out);

    header("Content-type: text/plain");
    echo $out;
    
    file_put_contents("/tmp/applications-" . $action . "-" . $machine . "-" . $user . ".log", $out);
}
?>