<?php
include ("config.inc.php");
include ("ldap.inc.php");

function cleandn($dn)
{
    $dn = preg_replace("/ou=/", "OU=", $dn);
    $dn = preg_replace("/cn=/", "CN=", $dn);
    return preg_replace("/dc=/", "DC=", $dn);
}

$licence = $_POST["licence"] ?? 0;
if ($licence == 1){
    $licence_file = "/etc/sambaedu/applications/veyon/licence.vlf";
    if (file_exists($licence_file)){
    echo file_get_contents($licence_file);
    }
    exit();
}
$nom_poste = $_POST["poste"] ?? $_GET["poste"] ?? "";
if (empty($nom_poste)){
    exit();
}

$liste_parcs = list_parcs($config, $nom_poste, "salle");
$json = json_decode(file_get_contents("/usr/share/sambaedu/applications/veyon/veyon.json"), true);
$local_json = "/etc/sambaedu/applications/veyon/local.json";
if (file_exists($local_json)) {
    $json = array_replace_recursive($json, json_decode(file_get_contents($local_json), true));
}
$key = file_get_contents("/usr/share/sambaedu/applications/veyon/default-pubkey.pem");
openssl_public_encrypt($config['ldap_admin_passwd'], $ldap_pass_crypted, $key, OPENSSL_PKCS1_OAEP_PADDING);
$json['LDAP'] = array(
    "BaseDN" => cleandn($config['ldap_base_dn']),
    "BindDN" => "CN=" . $config['ldap_admin_name'] . "," . $config['admin_rdn'] . "," . $config['ldap_base_dn'],
    "BindPassword" => bin2hex($ldap_pass_crypted),
    "ComputerContainersFilter" => "",
    "ComputerDisplayNameAttribute" => "cn",
    "ComputerGroupTree" => cleandn($config['parcs_rdn']),
    "ComputerGroupsFilter" => "(CN=" . $liste_parcs['name'] . ")",
    "ComputerHostNameAsFQDN" => false,
    "ComputerHostNameAttribute" => "name",
    "ComputerLocationAttribute" => "dn",
    "ComputerLocationsByAttribute" => false,
    "ComputerLocationsByContainer" => false,
    "ComputerMacAddressAttribute" => "networkAddress",
    "ComputerRoomAttribute" => "dn",
    "ComputerRoomMembersByAttribute" => false,
    "ComputerRoomMembersByContainer" => false,
    "ComputerRoomNameAttribute" => "cn",
    "ComputerTree" => cleandn($config['computers_rdn']),
    "ComputersFilter" => "(objectClass=computer)",
    "ConnectionSecurity" => 1,
    "GroupMemberAttribute" => "member",
    "GroupTree" => cleandn($config['groups_rdn']),
    "IdentifyGroupMembersByNameAttribute" => false,
    "LocationNameAttribute" => "cn",
    "QueryNamingContext" => false,
    "RecursiveSearchOperations" => true,
    "ServerHost" => $config['se4ad_name'],
    "ServerPort" => 389,
    "TLSVerifyMode" => 1,
    "UseBindCredentials" => true,
    "UserGroupsFilter" => "(|(CN=Eleves)(CN=Profs)(CN=Administratifs))",
    "UserLoginAttribute" => "cn",
    "UserLoginNameAttribute" => "cn",
    "UserTree" => cleandn($config['people_rdn']),
    "UsersFilter" => "(objectClass=person)"
);

$json["AccessControl"]["AccessControlRules"]["JsonStoreArray"][0]["Parameters"][0]["Argument"] = "CN=Eleves," . cleandn($config['groups_rdn']);
$json["AccessControl"]["AccessControlRules"]["JsonStoreArray"][1]["Parameters"][0]["Argument"] = "CN=Eleves," . cleandn($config['groups_rdn']);
$json["AccessControl"]["AccessControlRules"]["JsonStoreArray"][3]["Parameters"][0]["Argument"] = "CN=Eleves," . cleandn($config['groups_rdn']);
$json["AccessControl"]["AccessControlRules"]["JsonStoreArray"][4]["Parameters"][0]["Argument"] = "CN=Profs," . cleandn($config['groups_rdn']);
$json["AccessControl"]["AccessControlRules"]["JsonStoreArray"][5]["Parameters"][0]["Argument"] = "CN=Administratifs," . cleandn($config['groups_rdn']);
$json["AccessControl"]["AuthorizedUserGroups"][0] = "CN=Admins," . cleandn($config['groups_rdn']);
$json["AccessControl"]["AuthorizedUserGroups"][1] = "CN=Profs," . cleandn($config['groups_rdn']);
$json["AccessControl"]["AuthorizedUserGroups"][2] = "CN=Administratifs," . cleandn($config['groups_rdn']);

$json["DesktopServices"]["PredefinedWebsites"]["JsonStoreArray"][0]["Name"] = "ENT";
$json["DesktopServices"]["PredefinedWebsites"]["JsonStoreArray"][0]["Path"] = $config['openent_uri'];

//openssl_public_encrypt($config['vnc_password'], $vnc_pass_crypted, $key, OPENSSL_PKCS1_OAEP_PADDING);
//$json['ExternalVncServer']["Password"] = bin2hex($vnc_pass_crypted);

echo header('Content-type:application/json;charset=utf-8');

echo json_encode($json);

?>
