<?php

/*
 * construit un tableau à partir des différentes préférences.
 *
 */
function ff_import_policy($config, array $user = [], array $machine = [], $auto = true)
{
    $liste = [
        'default'
    ];
    if (isset($user['cn'])) {
        $liste[] = $user['cn'];
        foreach ($user['memberof'] as $group) {
            $liste[] = ldap_dn2cn($group);
        }
    }
    if (isset($machine['cn'])) {
        $liste[] = $machine['cn'];
        foreach ($machine['memberof'] as $parc) {
            $liste[] = ldap_dn2cn($parc);
        }
    }
    // 1 récupération des templates
    $policy = json_decode(file_get_contents("/usr/share/sambaedu/applications/firefox/default.json"), true)['policies'];

    // 2 valeurs automatiquement modifiées
    if ($auto) {
        $policy['PopupBlocking'] = [
            'Allow' => [
                "http://" . $config['se4fs_name'],
                $config['se4_url']
            ]
        ];
        $proxy_map = [
            'manuel' => "manual",
            'aucun' => "none",
            'automatique' => "autoDetect"
        ];

        $policy['Proxy'] = [
            'Mode' => $proxy_map[$config['proxy_type']],
            'Locked' => true,
            'UseHTTPProxyForAllProtocols' => true,
            'Passthrough' => "<local>",
            'AutoLogin' => false,
            'UseProxyForDNS' => false
        ];
        $policy['DNSOverHTTPS'] = [
            'Enabled' => false,
            'Locked' => true
        ];
        if ($config['proxy_type'] == "manuel" && ! empty($config['proxy_address']) && ! empty($config['proxy_port'])) {
            $policy['Proxy']['HTTPProxy'] = $config['proxy_address'] . ":" . $config['proxy_port'];
        }
    }
    // 3 ajout des modifs locales
    $files = scandir("/etc/sambaedu/applications/firefox");
    foreach ($liste as $nom) {
        foreach ($files as $file) {
            if (preg_match("@^(.*)\.json$@i", $file, $m)) {
                if ($m[1] == $nom) {
                    $local_policy = json_decode(file_get_contents("/etc/sambaedu/applications/firefox/" . $file), true)['policies'];
                    $policy = array_replace_recursive($policy, $local_policy);
                 }
            }
        }
    }
    return $policy;
}

function ff_export_policy($config, $policy, $path = "")
{
    if (! empty($path)) {
        return file_put_contents($path, json_encode([
            'policies' => $policy
        ], JSON_PRETTY_PRINT));
    } else {
        return json_encode([
            'policies' => $policy
        ]);
    }
}

function ff_form_policy($config, $policy)
{
    $html = "<h1>Marque Pages Firefox</h1>";
    $html .= '<form class="form" action="" method="post">';
    $key = 0;
    $links = $policy['Bookmarks'] ?? [];
    $folders = array_unique(array_column($links, "Folder"));
    if (count($links) > 0) {
        foreach ($links as $key => $link) {
            $html .= 'Titre : ';
            $html .= '<input type="text" name="Title[' . $key . ']" id="Title[' . $key . ']" value="' . $link['Title'] . '" size="20"  />';
            $html .= '<br />';
            $html .= 'URL du serveur lien : ';
            $html .= '<input type="text" name="URL[' . $key . ']" id="URL[' . $key . ']" value="' . $link['URL'] . '" size="50"  />';
            $html .= '<br />';
            $html .= 'Dossier : ';
            $html .= '<input type="text" name="Folder[' . $key . ']" id="Folder[' . $key . ']" value="' . $link['Folder'] . '" size="20"  />';
            // $html .= 'position : ';
            // $html .= '<input type="text" name="pos[' . $key . ']" id="pos[' . $key . ']" value="' . $key . '" size="2" />';
            $html .= '<br />';
            $html .= '<p><input color="red" type="submit" name="suppr[' . $key . ']" value="Supprimer ce lien"/></p>';
            $html .= '<br />';
        }
    }
    /**
     * Ajout d'un lien
     */
    $key += 1;
    $html .= "<h1>" . gettext("Ajouter un lien") . "</h1>";
    $html .= 'Titre : ';
    $html .= '<input type="text" name="Title[' . $key . ']" id="Title[' . $key . ']" value="" size="20"  />';
    $html .= '<br />';
    $html .= 'URL du serveur lien : ';
    $html .= '<input type="text" name="URL[' . $key . ']" id="URL[' . $key . ']" value="" size="50"  />';
    $html .= '<br />';
    $html .= 'Dossier : ';
    $html .= '<input type="text" name="Folder[' . $key . ']" id="Folder[' . $key . ']" value="' . $link['Folder'] . '" size="20"  />';
    // $html .= 'position : ';
    // $html .= '<input type="text" name="pos[' . $key . ']" id="pos[' . $key . ']" value="' . $key . '" size="2" />';
    $html .= '<br />';
    // page d'accueil
    $html .= "<h1>" . gettext("Page d'accueil") . "</h1>";
    $html .= 'URL : ';
    $html .= '<input type="text" name="Homepage" id="Homepage" value="' . @$policy['Homepage']['URL'] . '" size="50"  />';
    $html .= '<br />';
    $html .= '<input type="submit" name="valider" value="Valider les modifications"/>';
    $html .= '</form>';
    return $html;
}

// thunderbird
/*
 * construit un tableau à partir des différentes préférences.
 *
 */
function tb_import_policy($config, array $user = [], array $machine = [], $auto = true)
{
    $liste = [
        'default'
    ];
    if (isset($user['cn'])) {
        $liste[] = $user['cn'];
        foreach ($user['memberof'] as $group) {
            $liste[] = ldap_dn2cn($group);
        }
    }
    if (isset($machine['cn'])) {
        $liste[] = $machine['cn'];
        foreach ($machine['memberof'] as $parc) {
            $liste[] = ldap_dn2cn($parc);
        }
    }
    // 1 récupération des templates
    $policy = json_decode(file_get_contents("/usr/share/sambaedu/applications/thunderbird/default.json"), true)['policies'];

    // 2 valeurs automatiquement modifiées
    if ($auto) {
        $proxy_map = [
            'manuel' => "manual",
            'aucun' => "none",
            'automatique' => "autoDetect"
        ];

        $policy['Proxy'] = [
            'Mode' => $proxy_map[$config['proxy_type']],
            'Locked' => true,
            'UseHTTPProxyForAllProtocols' => true,
            'Passthrough' => "<local>",
            'AutoLogin' => false,
            'UseProxyForDNS' => false
        ];
        $policy['DNSOverHTTPS'] = [
            'Enabled' => false,
            'Locked' => true
        ];
        if ($config['proxy_type'] == "manuel" && ! empty($config['proxy_address']) && ! empty($config['proxy_port'])) {
            $policy['Proxy']['HTTPProxy'] = "http://" . $config['proxy_address'] . ":" . $config['proxy_port'];
        }
    }
    // 3 ajout des modifs locales
    $files = scandir("/etc/sambaedu/applications/thunderbird");
    foreach ($files as $file) {

        if (preg_match("@(.*)\.json@", $file, $m)) {
            if (in_array($m[1], $liste)) {
                $local_policy = json_decode(file_get_contents("/etc/sambaedu/applications/thunderbird/" . $file), true)['policies'];
                $policy = array_replace_recursive($policy, $local_policy);
            }
        }
    }

    return $policy;
}
?>