<?php
use function Sodium\randombytes_buf;

function make_shortcut($config, $name, $os, $user = "")
{
    $shortcuts = json_decode(file_get_contents("/etc/sambaedu/applications/shortcuts/shortcuts.json"), true);
    $key = array_search($name, array_combine(array_keys($shortcuts), array_column($shortcuts, 'name')));
    $shortcut = $shortcuts[$key];

    if (! empty($shortcut['windows']) && $os == "windows") {
        $tmp_path = sys_get_temp_dir() . "/" . $shortcut['name'] . "-" . microtime();
        $cmd = "/usr/bin/mslink -l '" . $shortcut['windows']['link'] . "' -n '" . $shortcut['name'] . "' -a '" . $shortcut['windows']['args'] . "' -w '" . $shortcut['windows']['path'] . "' -i '" . $shortcut['windows']['icon'] . "'";
        // file_put_contents(sys_get_temp_dir() . "/mslink", iconv("UTF-8", "ISO-8859-15", preg_replace("/\\\\/", "\\\\\\\\", $cmd)));
        // file_put_contents(sys_get_temp_dir() . "/mslink", preg_replace("/\\\\/", "\\\\\\\\", $cmd));
        // exec(iconv("UTF-8", "ISO-8859-15", preg_replace("/\\\\/", "\\\\\\\\", $cmd)));
        $out = " -o \"" . $tmp_path . "\"";
        exec(iconv("UTF-8", "ISO-8859-15", $cmd) . $out);
        return file_get_contents($tmp_path);
        unlink($tmp_path);
    }

    if (! empty($shortcut['linux']) && $os == "linux") {
        $out = "#!/usr/bin/env xdg-open
[Desktop Entry]
Encoding=UTF-8
Type=Application
Terminal=false
StartupNotify=false
Categories=Application
Exec=" . $shortcut['linux']['link'] . " " . $shortcut['linux']['args'] . "
Hidden=false
Name=" . $shortcut['name'] . "
Comment=Raccourci ajouté par Sambaedu\n";
        switch ($shortcut['place']) {
            case "startup":
                // \${HOME}/.config/autostart/$name.desktop
                $out .= "X-GNOME-Autostart-enabled=true\n";
                $out .= "Icon=/home/" . $user . "/.local/share/icons/" . $shortcut['name'] . ".png\n";
                break;
            case "desktop":
            // ne fonctionne pas bien pour Gnome, le raccourci doit être activé manuellement à chaque fois !
            case "taskbar":
                // "\${HOME}/.local/share/applications/"
                $out .= "Icon=/home/" . $user . "/.local/share/icons/" . $shortcut['name'] . ".png\n";
                break;
        }
        return $out;
    }
}

function make_shortcut_icon($shortcut)
{
    if (file_exists("/etc/sambaedu/applications/shortcuts/" . $shortcut . ".png")) {
        return (file_get_contents("/etc/sambaedu/applications/shortcuts/" . $shortcut . ".png"));
    } else {
        return (file_get_contents("../elements/images/system-run.png"));
    }
}

function shortcut_create_script($config, $user, $machine, $os, $action)
{
    if (! empty($machine)) {
        $machine = search_machine($config, $machine);
    } else {
        $machine = [];
    }
    if (! empty($user)) {
        $user = search_user($config, $user);
    } else {
        $cnx_user = get_machine_status($config, $machine['cn']);
        if (! empty($cnx_user['user'][0]['name'])) {
            $user = search_user($config, $cnx_user['user'][0]['name']);
        }
    }

    if (! empty($machine['dn'])) {
        $salle = ldap_dn2cn(ldap_dn2oudn($machine['dn']));
        // $parcs[] = $machine['cn'];
        foreach ($machine['memberof'] as $parc) {
            $parcs[] = ldap_dn2cn($parc);
        }
    } else {
        $salle = "";
    }
    $groups = [];
    $list_u = [];
    if (isset($user['cn'])) {
        foreach ($user['memberof'] as $group) {
            $groups[] = ldap_dn2cn($group);
        }
        $list_u = array_unique(array_merge([
            $user['cn']
        ], $groups));
    }
    $list_m = array_unique(array_merge([
        $machine['cn'],
        $salle
    ], $parcs));
    $script = "";
    if ($os == "windows" && $action == "logon") {
        $script .= "chcp 28605\r\n";
        $script .= "if exist \"%userprofile%\\AppData\\Roaming\\shortcuts.txt\" (for /F \"usebackq delims=\"  %%A in  (\"%userprofile%\\AppData\\Roaming\\shortcuts.txt\") do (del /f /q \"%%A\"))\r\n";
        $script .= "if exist \"%userprofile%\\AppData\\Roaming\\shortcuts.txt\" (del /f /q \"%userprofile%\\AppData\\Roaming\\shortcuts.txt\")\r\n";
    }
    $shortcuts = json_decode(file_get_contents("/etc/sambaedu/applications/shortcuts/shortcuts.json"), true);
    if (count($list_u) > 0) {
        foreach ($shortcuts as $shortcut) {
            if (@count(array_intersect(explode(",", $shortcut['owner']), $list_u)) > 0 && ! empty($shortcut['windows']['link']) && $os == "windows") {
                if ($action == "logon") {
                    switch ($shortcut['place']) {
                        case "startup":
                            $path = "%userprofile%\\AppData\\Roaming\\Microsoft\\Windows\\Start Menu\\Programs\\Startup\\";
                            break;
                        case "desktop":
                            $path = "\\\\se4fs\\users\\%username%\\Bureau\\";
                            break;
                        case "taskbar":
                            $path = "%userprofile%\\AppData\\Roaming\\Microsoft\\Internet Explorer\\Quick Launch\\User Pinned\\TaskBar\\";
                            break;
                    }
                    $script .= "curl.exe --output \"" . iconv("UTF-8", "ISO8859-15", $path . $shortcut['name']) . ".lnk\" -F \"action=file\" -F \"shortcut=" . iconv("UTF-8", "ISO8859-15", $shortcut['name']) . "\" -F \"os=windows\" -F \"machine=%computername%\" -F \"user=%userlogin%\" \"http://" . $config['se4fs_name'] . "/gpo/shortcuts_out.php\"\r\n";
                    $script .= "echo " . iconv("UTF-8", "ISO8859-15", $path . $shortcut['name']) . ".lnk>>\"%userprofile%\\AppData\\Roaming\\shortcuts.txt\"\r\n";
                } else {
                    switch ($shortcut['place']) {
                        case "startup":
                            $path = "%userprofile%\\AppData\\Roaming\\Microsoft\\Windows\\Start Menu\\Programs\\Startup\\";
                            break;
                        case "desktop":
                            $path = "\\\\se4fs\\users\\%username%\\Bureau\\";
                            break;
                        case "taskbar":
                            $path = "%userprofile%\\AppData\\Roaming\\Microsoft\\Internet Explorer\\Quick Launch\\User Pinned\\TaskBar\\";
                            break;
                    }
                    // $script .= "echo " . $path . $shortcut['name'] . ".lnk>>\"%userprofile%\\AppData\\Roaming\\shortcuts.txt\"\r\n";
                }
            } elseif (@count(array_intersect(explode(",", $shortcut['owner']), $list_u)) > 0 && ! empty($shortcut['linux']['link']) && $os == "linux") {
                if (file_exists("/etc/sambaedu/applications/shortcuts/" . $shortcut['name'] . ".png")) {
                    $script .= "mkdir -p \${HOME}/.local/share/icons\n";
                    $icon = "\${HOME}/.local/share/icons/" . $shortcut['name'] . ".png";
                    $script .= "[ -f \"$icon\" ] || curl -s -o $icon -F \"shortcut=" . $shortcut['name'] . "\" -F \"action=icon\" -F \"os=linux\" http://" . $config['se4fs_name'] . "/gpo/shortcuts_out.php\n";
                }
                $script .= "# $action pour " . implode(" ", $list_u) . "->" . $shortcut['owner'] . "\n";
                if ($action == "logon") {
                    switch ($shortcut['place']) {
                        case "startup":
                            $path = "\${HOME}/.config/autostart/";
                            break;
                        case "desktop":
                            $path = "\${HOME}/Bureau/";
                            break;
                        case "taskbar":
                            $path = "\${HOME}/.local/share/applications/";
                            $script .= "dconf read /org/gnome/shell/favorite-apps | grep -q \"" . $shortcut['name'] . ".desktop\"\n";
                            $script .= "if [ \$? -eq 1 ]; then\n";
                            $script .= "list=\$(dconf read /org/gnome/shell/favorite-apps|sed \"s/\[\(.*\)\]/[\\1, '" . $shortcut['name'] . ".desktop']/\")\n";
                            $script .= "dconf write /org/gnome/shell/favorite-apps \"\$list\"\n";
                            $script .= "fi\n";
                            break;
                    }
                    $script .= "mkdir -p \"$path\"\n";
                    $script .= "/usr/bin/curl -s -o " . $path . $shortcut['name'] . ".desktop -F \"action=file\" -F \"os=linux\" -F \"user=" . $user['cn'] . "\"  -F \"shortcut=" . $shortcut['name'] . "\"  http://" . $config['se4fs_name'] . "/gpo/shortcuts_out.php || true\n";
                    $script .= "chmod 755 \"" . $path . $shortcut['name'] . ".desktop\"\n";
                    $script .= "dbus-launch gio set  \"" . $path . $shortcut['name'] . ".desktop\" \"metadata::trusted\" true\n";
                } else {
                    switch ($shortcut['place']) {
                        case "startup":
                            $path = "\${HOME}/.config/autostart/";
                            break;
                        case "desktop":
                            $path = "\${HOME}/Bureau/";
                            // $script .= "rm -f \"" . $path . $shortcut['name'] . ".desktop\"\n";

                            break;
                        case "taskbar":
                            $path = "\${HOME}/.local/share/applications";
                            $script .= "list=\$(dconf read /org/gnome/shell/favorite-apps|sed \"s/, \\\"\(" . $shortcut['name'] . "\.desktop\)\\\"//\")\n";
                            $script .= "dconf write /org/gnome/shell/favorite-apps \"\$list\"\n";
                            break;
                    }
                }
            }
        }
    }
    // gestion des raccourcis machine
    // Windoze
    if (count($list_m) > 0) {
        foreach ($shortcuts as $shortcut) {
            if (count(array_intersect(explode(",", $shortcut['owner']), $list_m)) > 0 && ! empty($shortcut['windows']['link']) && $os == "windows") {
                switch ($action) {
                    case "startup":
                        switch ($shortcut['place']) {
                            case "startup":
                                $path = "C:\\ProgramData\\Microsoft\\Windows\\Start Menu\\Programs\\StartUp\\";
                                $script .= "curl.exe --output \"" . iconv("UTF-8", "ISO8859-15", $path . $shortcut['name']) . ".lnk\" -F \"action=file\" -F \"shortcut=" . $shortcut['name'] . "\" -F \"os=windows\" -F \"machine=%computername%\" -F \"user=%userlogin%\" \"http://" . $config['se4fs_name'] . "/gpo/shortcuts_out.php\"\r\n";
                                break;
                            case "desktop":
                                $path = "%public%\\Desktop\\";
                                $script .= "curl.exe --output \"" . iconv("UTF-8", "ISO8859-15", $path . $shortcut['name']) . ".lnk\" -F \"action=file\" -F \"shortcut=" . $shortcut['name'] . "\" -F \"os=windows\" -F \"machine=%computername%\" -F \"user=%userlogin%\" \"http://" . $config['se4fs_name'] . "/gpo/shortcuts_out.php\"\r\n";
                                break;
                        }
                        break;
                    case "logon":
                        switch ($shortcut['place']) {
                            case "taskbar":
                                $path = "%AppData%\\Microsoft\\Internet Explorer\\Quick Launch\\User Pinned\\TaskBar\\";
                                $script .= "curl.exe --output \"" . iconv("UTF-8", "ISO8859-15", $path . $shortcut['name']) . ".lnk\" -F \"action=file\" -F \"shortcut=" . $shortcut['name'] . "\" -F \"os=windows\" -F \"machine=%computername%\" -F \"user=%userlogin%\" \"http://" . $config['se4fs_name'] . "/gpo/shortcuts_out.php\"\r\n";
                                break;
                        }
                        break;
                    default:
                    // $script .= "del /f /q \"" . $path . $shortcut['name'] . ".lnk\"\r\n";
                }
                // Linux
            } elseif (count(array_intersect(explode(",", $shortcut['owner']), $list_m)) > 0 && ! empty($shortcut['linux']['link']) && $os == "linux") {
                $script .= "# $action pour " . implode(" ", $list_m) . " -> " . $shortcut['owner'] . "\n";
                switch ($action) {
                    case "startup":
                        // pas d'icone dans ce cas !
                        switch ($shortcut['place']) {
                            case "startup":
                                $path = "/etc/xdg/autostart/";
                                $script .= "/usr/bin/curl -s -o " . $path . $shortcut['name'] . ".desktop -F \"action=file\" -F \"os=linux\" -F \"shortcut=" . $shortcut['name'] . "\"  http://" . $config['se4fs_name'] . "/gpo/shortcuts_out.php || true\n";
                                $script .= "chmod 755 \"" . $path . $shortcut['name'] . ".desktop\"\n";
                                break;
                        }
                        break;
                    case "logon":
                        if (file_exists("/etc/sambaedu/applications/shortcuts/" . $shortcut['name'] . ".png")) {
                            $icon = "\${HOME}/.local/share/icons/" . $shortcut['name'] . ".png";
                            $script .= "[ -f \"$icon\" ] || curl -s -o $icon -F \"shortcut=" . $shortcut['name'] . "\" -F \"action=icon\" -F \"os=linux\" http://" . $config['se4fs_name'] . "/gpo/shortcuts_out.php\n";
                        }
                        switch ($shortcut['place']) {
                            case "desktop":
                                $path = "\${HOME}/Bureau/";
                                $script .= "/usr/bin/curl -s -o \"" . $path . $shortcut['name'] . ".desktop\" -F \"action=file\" -F \"os=linux\" -F \"user=" . $user['cn'] . "\"  -F \"shortcut=" . $shortcut['name'] . "\"  http://" . $config['se4fs_name'] . "/gpo/shortcuts_out.php || true\n";
                                $script .= "chmod 755 \"" . $path . $shortcut['name'] . ".desktop\"\n";
                                $script .= "dbus-launch gio set  \"" . $path . $shortcut['name'] . ".desktop\" \"metadata::trusted\" true";
                                break;
                            case "taskbar":
                                $path = "\${HOME}/.local/share/applications";
                                $script .= "dconf read /org/gnome/shell/favorite-apps | grep -q \"" . $shortcut['name'] . ".desktop\"\n";
                                $script .= "if [ \$? -eq 1 ]; then\n";
                                $script .= "list=\$(dconf read /org/gnome/shell/favorite-apps|sed \"s/\[\(.*\)\]/[\\1, '" . $shortcut['name'] . ".desktop']/\")\n";
                                $script .= "dconf write /org/gnome/shell/favorite-apps \"\$list\"\n";
                                $script .= "fi\n";
                                $script .= "/usr/bin/curl -s -o \"" . $path . $shortcut['name'] . ".desktop\" -F \"action=file\" -F \"os=linux\" -F \"user=" . $user['cn'] . "\"  -F \"shortcut=" . $shortcut['name'] . "\"  http://" . $config['se4fs_name'] . "/gpo/shortcuts_out.php || true\n";
                                $script .= "chmod 755 \"" . $path . $shortcut['name'] . ".desktop\"\n";
                                $script .= "dbus-launch gio set  \"" . $path . $shortcut['name'] . ".desktop\" \"metadata::trusted\" true";
                                break;
                        }
                        break;
                    default:
                        switch ($shortcut['place']) {
                            case "startup":
                                $path = "\${HOME}/.config/autostart/";
                                break;
                            case "desktop":
                                $path = "\${HOME}/Bureau/";
                                $script .= "rm -f \"" . $path . $shortcut['name'] . ".desktop\"\n";
                                break;
                            case "taskbar":
                                $path = "\${HOME}/.local/share/applications";
                                $script .= "list=\$(dconf read /org/gnome/shell/favorite-apps|sed \"s/, '\(" . $shortcut['name'] . "\.desktop\)'//\")\n";
                                $script .= "dconf write /org/gnome/shell/favorite-apps \$list\n";
                                break;
                        }
                        break;
                }
            }
        }
    }
    return $script;
}

function export_shotcuts($config, $shortcuts)
{
    return file_put_contents("/etc/sambaedu/applications/shortcuts/shortcuts.json", json_encode($shortcuts, JSON_PRETTY_PRINT));
}

function select_expandable($key, $name, $choices, $values, $expand)
{
    $html = "";
    if ($expand) {
        $html = "<select name=\"$name[$key]\" onclick=\"submit();\">";
        foreach ($choices as $choice) {
            $html .= "<option value=\"$choice\" ";
            if (in_array($choice, $values)) {
                $html .= "selected";
            }
            $html .= ">$value</option>";
        }
        $html .= "</select>";
    } else {
        $html = "<input name=\"expand[$key]\" type=\"submit\" value=\"";

        $html .= implode(" ", $values);
        $html .= "\>";
    }
    return $html;
}

/**
 * génère un formulaire pour un raccourci.
 * remplit le tableau $shortcuts[$key] si le POST[shortcut] contient des infos et que POST[valider][$key] est défini
 *
 * @param unknown $config
 * @param unknown $shortcuts
 * @param unknown $key
 * @return string
 */
function form_shortcut($config, &$shortcuts, $key)
{
    $shortcut = $_POST['shortcut'] ?? [];
    $html = "";
    if (! empty($_POST['valider'][$key]) && ! empty($shortcut['name'])) {
        // on sauvegarde les valeurs en POST
        $shortcuts[$key] = $shortcut;
        if (! empty($_FILES['icon']['name'])) {
            $dest_file = sys_get_temp_dir() . "/" . $_FILES['icon']['name'];
            if (file_exists($dest_file)) {
                unlink($dest_file);
            }
            if (! is_uploaded_file($_FILES['icon']['tmp_name'])) {
                // return "<p style='color:red'>Impossible d'importer le fichier.</p><br>\n";
            }
            if (! move_uploaded_file($_FILES['icon']['tmp_name'], $dest_file)) {
                // return "<p style='color:red'>Impossible de copier le fichier.</p>\n";
            }
            if (! $imagick = new Imagick($dest_file)) {
                unset($_FILES);
                unset($_POST);
                return "<p style='color:red'>Format d'image invalide.</p><br>\n";
            }
            $imagick->resizeimage(128, 128, Imagick::FILTER_QUADRATIC, 1);
            $imagick->setImageFormat("png");
            $imagick->writeImage("/etc/sambaedu/applications/shortcuts/" . $shortcut['name'] . ".png");
            unset($_FILES);
            unset($_POST);
        }
    } else {
        // on remplit le formulaire à partir du fichier
        $shortcut = $shortcuts[$key];
    }

    // $html .= "<pre>" . print_r($shortcuts, true) . "</pre>";
    if (! empty($_POST['del'][$key])) {
        unset($shortcuts[$key]);
        unset($shortcut);
    } elseif (! empty($_POST['edit'][$key])) {

        $html .= '<img src="../gpo/shortcuts_out.php?action=icon&shortcut=' . urlencode($shortcut['name']) . '" height=50 width=50/>';
        $html .= 'Nom : ';
        $html .= '<input type="text" name="shortcut[name]" value="' . @$shortcut['name'] . '" size="20"  />';

        $html .= ' Icone (Non utilisée pour Windows) :  <input type="file" name="icon" value=""/>';
        $html .= '<br>Emplacement ';
        $places = [
            "desktop" => "bureau",
            "startup" => "demarrage auto",
            "taskbar" => "barre des  tâches (ne fonctionne pas avec Windows)"
        ];
        $html .= '<select name="shortcut[place]"/>';
        foreach ($places as $k => $val) {
            $html .= "<option value=$k";
            if ($k == @$shortcut['place']) {
                $html .= " selected>";
            } else {
                $html .= ">";
            }
            $html .= $val . "</option>";
        }
        $html .= '</select><br>';
        $html .= 'Propriétaire (utilisateur,groupe/machine,Salle,parc) séparé par des , : ';
        $html .= '<input type="text" name="shortcut[owner]" id="name" value="' . @$shortcut['owner'] . '" size="20"  />';
        $html .= '<br />';

        $html .= 'chemin de la cible  windows (UNC, pas de lecteur réseau) : ';
        $html .= '<input type="text" name="shortcut[windows][link]" value="' . @$shortcut['windows']['link'] . '" size="50"  />';
        $html .= '<br>';
        $html .= 'Arguments windows : ';
        $html .= '<input type="text" name="shortcut[windows][args]" value="' . @$shortcut['windows']['args'] . '" size="50"  />';
        $html .= '<br>';
        $html .= 'Dossier de base Windows (si besoin) : ';
        $html .= '<input type="text" name="shortcut[windows][path]" value="' . @$shortcut['windows']['path'] . '" size="50"  />';
        $html .= '<br>';
        $html .= 'Icone Windows (si différente de l\'exe) : ';
        $html .= '<input type="text" name="shortcut[windows][icon]" value="' . @$shortcut['windows']['icon'] . '" size="50"  />';
        $html .= '<br>';

        $html .= 'chemin de la cible  linux: ';
        $html .= '<input type="text" name="shortcut[linux][link]" value="' . @$shortcut['linux']['link'] . '" size="50"  />';
        $html .= '<br>';
        $html .= 'Arguments linux : ';
        $html .= '<input type="text" name="shortcut[linux][args]" value="' . @$shortcut['linux']['args'] . '" size="50"  />';
        $html .= '<br>';
        $html .= 'Dossier de base linux (si besoin) : ';
        $html .= '<input type="text" name="shortcut[linux][path]" value="' . @$shortcut['linux']['path'] . '" size="50"  />';
        $html .= '<br>';
        $html .= "<input type=submit name=valider[$key] value=\"Valider\">";
    } elseif (! empty($shortcut['name'])) {
        $html .= '<img src="../gpo/shortcuts_out.php?action=icon&shortcut=' . urlencode($shortcut['name']) . '" height=50 width=50/>';
        $html .= "<input type=submit name=edit[$key] value=\"modifier " . @$shortcut['name'] . "\"> (" . @$shortcut['place'] . " / " . @$shortcut['owner'] . ") ";
        $html .= "<input type=submit name=del[$key] value=\"Supprimer\">";
    } else {
        $html .= "<input type=submit name=edit[$key] value=\"Nouveau...\">";
    }
    $html .= "<p>";
    return $html;
}

function list_shortcuts($config, $owner = "")
{
    $html = "";
    $shortcuts = json_decode(file_get_contents("/etc/sambaedu/applications/shortcuts/shortcuts.json"), true) ?? [];
    if (count($shortcuts) > 0) {
        foreach ($shortcuts as $key => $shortcut) {
            if (empty($owner) || $shortcut['owner'] == $owner) {
                $html .= form_shortcut($config, $shortcuts, $key);
            }
        }
        if (! empty($_POST['valider'][$key + 1])) {
            $key ++;
            $html .= form_shortcut($config, $shortcuts, $key);
        }
        file_put_contents("/etc/sambaedu/applications/shortcuts/shortcuts.json", json_encode($shortcuts, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
        $shortcuts[$key + 1]['owner'] = $owner;
        $html .= form_shortcut($config, $shortcuts, $key + 1);
    } else {
        if (! empty($owner)) {
            $shortcuts[0]['owner'] = $owner;
        }
        $html .= form_shortcut($config, $shortcuts, 0);
        file_put_contents("/etc/sambaedu/applications/shortcuts/shortcuts.json", json_encode($shortcuts, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE | JSON_UNESCAPED_SLASHES));
    }
    return $html;
}
