<?php
/**

 * affiche le statut des action à distance en cours

 * @Projet SambaEdu

 * @auteurs denis bonnenfant

 * @Licence Distribue selon les termes de la licence GPL

 */
require_once "entete.inc.php";
include "ihm.inc.php";
require_once ("ldap.inc.php");
require_once ("dhcpd.inc.php");
require "ipxe_functions.inc.php";
require_once ("fonc_outils.inc.php");
require_once ("fonc_parc.inc.php");
require "actions.inc.php";
require "windows.inc.php";
require_once "logs.inc.php";

// Traduction
require_once ("lang.inc.php");
$type = $_POST['type'] ?? $_GET['type'] ?? "";
$id = $_POST['id'] ?? "";
$action = $_POST['action'] ?? $_GET['action'] ?? "";
$filtre = $_POST['filtre'] ?? "";
$choix = $_POST['choix'] ?? 0;
$modele = $_POST['modele'] ?? "";
$name = $_POST['name'] ?? "";
$role = $_POST['role'] ?? "";
$parc = $_POST['parc'] ?? $_GET['parc'] ?? "";
$clone = $_GET['clone'] ?? $_POST['clone'] ?? "";
// debug_var();

if (! empty($clone))
    $clones = array(
        $clone
    );
else
    $clones = $_POST['clones'] ?? array();
if (! empty($name) && ! empty($role)) {
    if ($role == "modele") {
        $modele = $name;
        $action = "new";
        unset($name);
    } elseif ($role == "clone" || $role == "install") {
        $clones[0] = $name;
        $action = "add";
        unset($name);
    }
}
// aide
$_SESSION["pageaide"] = "Installation";

if (have_right($config, "computer_is_admin")) {
    echo "<h1>Gestion des postes</h1>\n";
    $page = "lance_action.php";
    check_system_accounts($config);
    // echo refresh_page("install");
    if (! empty($type))
        echo "<h2>Type d'actions : $type</h2>\n";
    echo "<FORM name=\"install\" action=\"" . $page . "\" method=\"post\">\n";
    if ($type == "voir" && ! empty($id)) {
        echo form_action_membres($config, $id);
        echo form_action_clonage();
        echo form_hidden("type", "clonage");
    } elseif ($type == "supprimer" && ! empty($id)) {
        delete_action($id);
        echo form_actions_statut();
        echo form_action_type();
    } elseif ($type == "clonage") {
        if (! file_exists("/var/www/sambaedu/ipxe/sysrescuecd/action.php") || ! file_exists("/var/sambaedu/unattended/install/os/sysresccd/")) {
            echo "Un outil nécessaire au bon fonctionnement du clonage semble manquant sur le serveur !";
            echo "<ul>\n";
            echo "<li>Vous devez installer le module sambaedu-clonage et lancer /usr/share/sambaedu/scripts/install-sysrescuecd-iso.sh</li>\n";
            echo "</ul>\n";
            include ("pdp.inc.php");
            die();
        }
        echo form_hidden("parc", $parc);
        if (empty($name)) {
            if (empty($action) || ($action == "submit")) {
                if (empty($id)) {
                    // pas d'action choisie, on affiche la liste complete
                    echo form_actions_statut($type);
                    echo form_action_clonage();
                } else {
                    echo form_action_membres($config, $id);
                    echo form_action_clonage();
                }
            } elseif ($action == "new") {
                if (empty($modele)) {
                    echo form_choix_poste($config, $action, $filtre, $choix, "modele", $id, $parc);
                    echo form_hidden("action", $action);
                    echo form_hidden("id", $id);
                } else {
                    $machine = get_action($config, $modele);
                    if ($machine['action']['keep'])
                        $res = set_action($config, $modele, "clonage", "", "", "modele", "rescuecd", - 1);
                    elseif (! empty($id))
                        $res = set_action($config, $modele, "clonage", $id, "", "modele", "sysprep", - 1);
                    else {
                        $res = set_action($config, $modele, "clonage", "new", "", "modele", "sysprep", - 1);
                        $id = $res['netbootinitialization'];
                    }
                    echo form_action_membres($config, $id);
                    echo form_action_clonage($action);
                }
            } elseif ($action == "keep") {
                toggle_action_keep($id);
                echo form_action_membres($config, $id);
                echo form_action_clonage($action);
            } elseif ($action == "add") {
                if (count($clones) == 0) {
                    echo form_choix_poste($config, $action, $filtre, $choix, "clone", $id, $parc);
                    echo form_hidden("id", $id);
                    echo form_hidden("action", $action);
                } else {
                    if (empty($id)) {
                        echo form_actions_statut("clonage");
                        echo form_hidden("action", $action);
                        echo form_hidden("clone", $clones[0]);
                    } else {
                        foreach ($clones as $clone) {
                            $script = "rescuecd";
                            $res = set_action($config, $clone, "clonage", $id, "", "clone", $script, - 1);
                        }
                        echo form_action_membres($config, $id);
                        echo form_action_clonage($action);
                    }
                }
            } elseif ($action == "remove") {
                if (count($clones) > 0) {

                    foreach ($clones as $clone) {
                        $token = get_action($config, $clone)['netbootmachinefilepath'];
                        $res = delete_action_members($token);
                    }
                    echo form_action_membres($config, $id);
                    echo form_action_clonage($action);
                }
            } elseif ($action == "del") {
                delete_action($id);
                echo form_actions_statut($type);
            } elseif ($action == "prepare") {
                $poste = get_action_member($config, $id, "modele")[0];
                echo start_poste($config, "reboot", $poste);
                echo form_action_membres($config, $id);
                echo form_action_clonage($action);
            } elseif ($action == "start") {
                $liste = get_action_member($config, $id, "clone");
                $poste = get_action_member($config, $id, "modele")[0];
                if (get_action($config, $poste)['action']['script'] == "sysprep") {
                    $liste[] = $poste;
                }
                foreach ($liste as $poste) {
                    echo start_poste($config, "reboot", $poste);
                }
                echo form_action_membres($config, $id);
                echo form_action_clonage($action);
            } elseif ($action == "reset") {
                $liste = get_action_member($config, $id, "clone");
                $poste = get_action_member($config, $id, "modele")[0];
                $liste[] = $poste;
                foreach ($liste as $poste) {
                    set_action($config, $poste, "clonage", $id, "", "", "rescuecd", - 1);
                    echo start_poste($config, "reboot", $poste);
                }
                echo form_action_membres($config, $id);
                echo form_action_clonage();
            } elseif ($action == "disk") {
                echo form_action_membres($config, $id);
                echo form_choix_partitions($id);
                echo form_action_clonage($action);
            }
        } else {
            // choix du rôle
            echo form_choix_role();
            echo form_hidden("name", $name);
        }
        echo form_hidden("type", $type);
    } elseif ($type == "install") {
        if (! file_exists("/var/sambaedu/unattended/install/os/Win10/sources/boot.wim") && ! file_exists("/var/sambaedu/unattended/install/os/debian-installer")) {
            echo "Un outil nécessaire au bon fonctionnement du module d'installation semble manquant sur le serveur !";
            echo "<ul>\n";
            echo "<li>Vous devez installer le module sambaedu-client-linux pour déployer des clients Linux</li>\n";
            echo "<li>Vous devez avoir placé au préalable l'image iso Windows 10 et lancer /usr/share/sambaedu/scripts/install-win-iso.sh - voir la documentation</li>\n";
            echo "</ul>\n";
            include ("pdp.inc.php");
            die();
        }
        echo form_hidden("parc", $parc);
        if (empty($action)) {
            echo form_choix_install();
            echo form_hidden("type", $type);
        } else {
            if (count($clones) == 0) {
                echo form_choix_poste($config, $action, $filtre, $choix, "install", $id, $parc);
                echo form_hidden("type", $type);
            } else {
                foreach ($clones as $name) {
                    echo form_hidden("clones[]", $name);
                    $res = set_action($config, $name, "install", "", "", "", $action, - 1);
                    if (empty($res['networkaddress'])) {
                        echo "ERREUR, le poste n'a pas d'adresse MAC enregistrée, et donc ne peut pas être installé<br>Vous devez au minimum l'allumer, ou mieux reserver son IP\n";
                    } else {
                        echo "Le poste exécutera l'action \"" . $action . "\" sous l'id " . $res['netbootinitialization'] . " au prochain redémarrage. Vérifiez que le poste est bien configuré pour démarrer en PXE, ou appuyez sur F12\n";
                        echo start_poste($config, "reboot", $name, true);
                    }
                }
            }
        }
    } elseif ($type == "wpkg") {
        echo form_hidden("id", $id);
        echo form_hidden("action", "wpkg");
        echo form_hidden("type", $type);
        echo form_hidden("parc", $parc);
        if (count($clones) == 0) {
            echo form_choix_poste($config, "wpkg", $filtre, $choix, "wpkg", $id, $parc);
        } else {
            foreach ($clones as $name) {
                echo form_hidden("clones[]", $name);
                $res = set_action($config, $name, "install", "", "", "", "wpkg", - 1);
                echo start_poste($config, "reboot", $name, true);
            }
        }
    } elseif ($type == "renomme") {
        echo form_hidden("type", $type);
        echo form_hidden("parc", $parc);
        if (empty($modele)) {
            echo form_new_name($parc, $clones);
        } else {
            echo form_hidden("modele", $modele);
            if (count($clones) == 0) {
                echo form_choix_poste($config, "renomme", $filtre, $choix, "renomme", $id, $parc);
            } else {
                $i = 1;
                foreach ($clones as $name) {
                    echo form_hidden("clones[]", $name);
                    if (count($clones) == 1){
                        $new_name = $modele;
                    } else {
                        $new_name = $modele . "-" . sprintf("%02d", $i ++);
                    }
                    $res = set_action($config, $name, "renomme", "", "", $new_name, "renomme", - 1);
                    echo start_poste($config, "reboot", $name, true);
                }
            }
        }

        /*
         * if (empty($name)) {
         * echo form_choix_poste($config, "renommage", $filtre, $choix, "install", $id);
         * echo form_hidden("type", $type);
         * } elseif (empty($modele)) {
         * echo form_new_name($name);
         * echo form_hidden("type", $type);
         * echo form_hidden("name", $name);
         * } else {
         * $res = set_action($config, $name, "renomme", "", "", $modele, "renomme", - 1);
         * echo form_hidden("type", $type);
         * echo form_hidden("name", $name);
         * echo form_action_membres($config, $res['netbootinitialization']);
         * echo start_poste($config, "reboot", $name, true);
         * }
         */
    } elseif ($type == "post") {
        if (empty($name)) {
            echo form_choix_poste($config, "post", $filtre, $choix, "install", $id);
            echo form_hidden("type", $type);
        } else {
            $res = set_action($config, $name, "install", "", "", "", "post", - 1);
            echo form_hidden("type", $type);
            echo form_hidden("name", $name);
            echo form_action_membres($config, $res['netbootinitialization']);
            echo start_poste($config, "reboot", $name, true);
        }
    } elseif ($type == "reboot") {
        echo start_poste($config, "reboot", $name, true);
    } else {
        echo form_actions_statut();
        echo form_action_type($type);
    }
    echo "</form>";
    echo "<FORM action=\"" . $page . "\" method=\"post\">\n";
    echo " <input type=\"submit\" value=\"Retour...\">\n";
    echo "</form>";
}
include ("pdp.inc.php");
?>    